#include <windows.h>
#include <stdio.h>

#define START_ACTION_BTN_ID 		1001 		// 弤ť ID

#define ENGLISH						0			// Ӣ
#define CHINESE						1			// 
		
#define INFO_LEFT_MARGIN			40			// ߾

// 
WNDCLASSEX wc;
HWND hwnd;
MSG msg;
HWND SystemLang;
HWND SystemVersion;
HWND ActionServerText;
HWND ActionServerAddr;
HWND ActionBtn;


// ǰѡ
int CurSystemLang  = 0;

// ǰϵͳ汾ѡ
int CurSystemVersion = 0;

// żϢͶӦʾϢĽṹ
typedef struct
{
	char *Key;
	char *English;
	char *Chinese;
}SYSTEM_VERSION,*SYSTEM_VERSION_PTR;

//żϢĽṹ
typedef struct
{
	char *Key;
	char *ActionServer;
}ACTION_INFO,*ACTION_INFO_PTR;


// б
const char *SystemLangList[] = {
	"English",
	"",
	NULL,
};

// ı
const char *ActionServerStr[] = {
	"Action Server : ",
	" : ",
};

// ťı
const char *ActionBtnStr[] = {
	"Start Action",
	"ʼ",
};

ACTION_INFO ActionInfo;

//ʼ汾Ϣ
const SYSTEM_VERSION SystemVersionList[] = {
    {.Key = "FJ82H-XT6CR-J8D7P-XQJJ2-GPDD4", .English = "Windows 7 Pro", .Chinese = "Windows 7 רҵ"},
    {.Key = "MRPKT-YTG23-K7D7T-X2JMM-QY7MG", .English = "Windows 7 Pro N", .Chinese = "Windows 7 רҵ N"},
    {.Key = "W82YF-2Q76Y-63HXB-FGJG9-GF7QX", .English = "Windows 7 Pro E", .Chinese = "Windows 7 רҵ E"},
    {.Key = "33PXH-7Y6KF-2VJC9-XBBR8-HVTHH", .English = "Windows 7 Enterprise", .Chinese = "Windows 7 ҵ"},
    {.Key = "YDRBP-3D83W-TY26F-D46B2-XCKRJ", .English = "Windows 7 Enterprise N", .Chinese = "Windows 7 ҵ N"},
    {.Key = "C29WB-22CC8-VJ326-GHFJW-H9DH4", .English = "Windows 7 Enterprise E", .Chinese = "Windows 7 ҵ E"},
    {.Key = "NG4HW-VH26C-733KW-K6F98-J8CK4", .English = "Windows 8 Pro", .Chinese = "Windows 8 רҵ"},
    {.Key = "XCVCF-2NXM9-723PB-MHCB7-2RYQQ", .English = "Windows 8 Pro N", .Chinese = "Windows 8 רҵ N"},
    {.Key = "32JNW-9KQ84-P47T8-D8GGY-CWCK7", .English = "Windows 8 Enterprise", .Chinese = "Windows 8 ҵ"},
    {.Key = "JMNMF-RHW7P-DMY6X-RF3DR-X2BQT", .English = "Windows 8 Enterprise N", .Chinese = "Windows 8 ҵ N"},
    {.Key = "GCRJD-8NW9H-F2CDX-CCM8D-9D6T9", .English = "Windows 8.1 Pro", .Chinese = "Windows 8.1 רҵ"},
    {.Key = "HMCNV-VVBFX-7HMBH-CTY9B-B4FXY", .English = "Windows 8.1 Pro N", .Chinese = "Windows 8.1 רҵ N"},
    {.Key = "MHF9N-XY6XB-WVXMC-BTDCT-MKKG7", .English = "Windows 8.1 Enterprise", .Chinese = "Windows 8.1 ҵ"},
    {.Key = "TT4HM-HN7YT-62K67-RGRQJ-JFFXW", .English = "Windows 8.1 Enterprise N", .Chinese = "Windows 8.1 ҵ N"},
    {.Key = "TX9XD-98N7V-6WMQ6-BX7FG-H8Q99", .English = "Windows 10/11 Home", .Chinese = "Windows 10/11 ͥ"},
    {.Key = "PVMJN-6DFY6-9CCP6-7BKTT-D3WVR", .English = "Windows 10/11 Home zh-cn", .Chinese = "Windows 10/11 ͥİ"},
    {.Key = "W269N-WFGWX-YVC9B-4J6C9-T83GX", .English = "Windows 10/11 Pro", .Chinese = "Windows 10/11 רҵ"},
    {.Key = "MH37W-N47XK-V7XM9-C7227-GCQG9", .English = "Windows 10/11 Pro N", .Chinese = "Windows 10/11 רҵ N"},
    {.Key = "NRG8B-VKK3Q-CXVCJ-9G2XF-6Q84J", .English = "Windows 10/11 Pro Workstation", .Chinese = "Windows 10/11 רҵվ"},
    {.Key = "9FNHH-K3HBT-3W4TD-6383H-6XYWF", .English = "Windows 10/11 Pro Workstation N", .Chinese = "Windows 10/11 רҵվ N"},
    {.Key = "6TP4R-GNPTD-KYYHQ-7B7DP-J447Y", .English = "Windows 10/11 Pro Edu", .Chinese = "Windows 10/11 רҵ"},
    {.Key = "YVWGF-BXNMC-HTQYQ-CPQ99-66QFC", .English = "Windows 10/11 Pro Edu N", .Chinese = "Windows 10/11 רҵ N"},
    {.Key = "NW6C2-QMPVW-D7KKK-3GKT6-VCFB2", .English = "Windows 10/11 Edu", .Chinese = "Windows 10/11 "},
    {.Key = "2WH4N-8QGBV-H22JP-CT43Q-MDWWJ", .English = "Windows 10/11 Edu N", .Chinese = "Windows 10/11  N"},
    {.Key = "NPPR9-FWDCX-D2C8J-H872K-2YT43", .English = "Windows 10/11 Enterprise", .Chinese = "Windows 10/11 ҵ"},
    {.Key = "DPH2V-TTNVB-4X9Q3-TJR4H-KHJW4", .English = "Windows 10/11 Enterprise N", .Chinese = "Windows 10/11 ҵ N"},
    {.Key = "YYVX9-NTFWV-6MDM3-9PT4T-4M68B", .English = "Windows 10/11 Enterprise G", .Chinese = "Windows 10/11 ҵ G"},
    {.Key = "44RPN-FTY23-9VTTB-MP9BX-T84FV", .English = "Windows 10/11 Enterprise G N", .Chinese = "Windows 10/11 ҵ G N"},
    {.Key = "M7XTQ-FN8P6-TTKYV-9D4CC-J462D", .English = "Windows 10/11 LTSC", .Chinese = "Windows 10/11 ְ֧"},
    {.Key = "92NFX-8DJQP-P6BBQ-THF9C-7CG2H", .English = "Windows 10/11 LTSC N", .Chinese = "Windows 10/11 ְ֧ N"},
    {.Key = "KBN8V-HFGQ4-MGXVD-347P6-PDQGT", .English = "Windows 10/11 IoT LTSC", .Chinese = "Windows 10/11  ְ֧"},
    {.Key = "DCPHK-NFMTC-H88MJ-PFHPY-QJ4BJ", .English = "Windows 10/11 LTSB 2016", .Chinese = "Windows 10/11 ְ֧ 2016"},
    {.Key = "QFFDN-GRT3P-VKWWX-X7T3R-8B639", .English = "Windows 10/11 LTSB 2016 N", .Chinese = "Windows 10/11 ְ֧ 2016 N"},
    {.Key = "VDYBN-27WPP-V4HQT-9VMD4-VMK7H", .English = "Windows Server 2022 Standard", .Chinese = "Windows Server 2022 ׼"},
    {.Key = "WX4NM-KYWYW-QJJR4-XV3QB-6VM33", .English = "Windows Server 2022 Datacenter", .Chinese = "Windows Server 2022 İ"},
    {.Key = "NTBV8-9K7Q8-V27C6-M2BTV-KHMXV", .English = "Windows Server 2022 Datacenter Azure", .Chinese = "Windows Server 2022 İ Azure"},
    {.Key = "N69G4-B89J2-4G8F4-WWYCC-J464C", .English = "Windows Server 2019 Standard", .Chinese = "Windows Server 2019 ׼"},
    {.Key = "WMDGN-G9PQG-XVVXX-R3X43-63DFG", .English = "Windows Server 2019 Datacenter", .Chinese = "Windows Server 2019 İ"},
    {.Key = "WVDHN-86M7X-466P6-VHXV7-YY726", .English = "Windows Server 2019 Datacenter Azure", .Chinese = "Windows Server 2019 İ Azure"},
    {.Key = "WC2BQ-8NRM3-FDDYY-2BFGV-KHKQY", .English = "Windows Server 2016 Standard", .Chinese = "Windows Server 2016 ׼"},
	{.Key = "CB7KF-BWN84-R7R2Y-793K2-8XDDG", .English = "Windows Server 2016 Datacenter", .Chinese = "Windows Server 2016 İ"},
	{.Key = "JCKRF-N37P4-C2D82-9YXRT-4M63B", .English = "Windows Server 2016 Datacenter Azure", .Chinese = "Windows Server 2016 İ Azure"},
	{.Key = "N2KJX-J94YW-TQVFB-DG9YT-724CC", .English = "Windows Server Standard Half Year", .Chinese = "Windows Server ׼ "},
	{.Key = "6NMRW-2C8FM-D24W7-TQWMY-CWH2D", .English = "Windows Server Datacenter Half Year", .Chinese = "Windows Server İ "},
	{.Key = NULL, .English = NULL, .Chinese = NULL},
};

int GetSystemLangLen(void);
int GetSystemListLen(void);
void TranslateApp(void);
void RunSlmgrCommand(const char* command);
void ExecActionCommand(void);


/* ϢĻص */
LRESULT CALLBACK WndProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam) {
	
	char Buffer[256] = {0x00};
	
    switch(Message) {
//        case WM_CREATE: {
//            // زôͼ
//            HICON hicon = (HICON)LoadImage(GetModuleHandleW(NULL), MAKEINTRESOURCE(IDI_ICON), 
//                IMAGE_ICON, 0, 0, LR_DEFAULTCOLOR | LR_DEFAULTSIZE);
//                
//            if (hicon) 
//			{
//			    SendMessage(hwnd, WM_SETICON, ICON_BIG, (LPARAM)hicon);
//			    SendMessage(hwnd, WM_SETICON, ICON_SMALL, (LPARAM)hicon);
//			} else {
//			    MessageBox(NULL, "Failed to load icon!", "Error", MB_OK | MB_ICONERROR);
//			}
//            break;
//        }
        case WM_DESTROY: {
            PostQuitMessage(0);
            break;
        }
        case WM_COMMAND:
        	// ťĵ¼
    	    if (LOWORD(wParam) == START_ACTION_BTN_ID) {  // жϰťǷ񱻵
				// ϢԿ
				ActionInfo.Key = SystemVersionList[CurSystemVersion].Key;
    	    
				// Ϣַ
				GetWindowText(ActionServerAddr,Buffer,sizeof(Buffer));
				ActionInfo.ActionServer = Buffer;
				ExecActionCommand();
		    }
        	
        	// бĵ¼
		    if (HIWORD(wParam) == CBN_SELCHANGE) {
		        // жĸ ComboBox ѡ
		        HWND hComboBox = (HWND)lParam;
		
		        if (hComboBox == SystemLang) 
				{
					// 
					CurSystemLang = SendMessage(hComboBox, CB_GETCURSEL, 0, 0);
					
					TranslateApp();
					
		        } else if (hComboBox == SystemVersion) 
				{ 
					// ѡϵͳ汾
					CurSystemVersion = SendMessage(hComboBox, CB_GETCURSEL, 0, 0);
					
					// ϢԿ
					ActionInfo.Key = SystemVersionList[CurSystemVersion].Key;
		        }
		    }
		    break;
		
        default:
            return DefWindowProc(hwnd, Message, wParam, lParam);
    }
    return 0;
}

/* Win32 ڵ */
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow) {
		
    memset(&wc,0,sizeof(wc));
    wc.cbSize         = sizeof(WNDCLASSEX);
    wc.lpfnWndProc    = WndProc;
    wc.hInstance      = hInstance;
    wc.hCursor        = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground  = (HBRUSH)(COLOR_WINDOW+1);
    wc.lpszClassName  = "WindowClass";
	wc.hIcon = LoadIcon(hInstance, "A");
	wc.hIconSm = LoadIcon(hInstance, "A");

    if(!RegisterClassEx(&wc)) {
        MessageBox(NULL, "Window Registration Failed!","Error!",MB_ICONEXCLAMATION|MB_OK);
        return 0;
    }

    hwnd = CreateWindowEx(
        WS_EX_CLIENTEDGE,
        "WindowClass",
        "Windowsv1.0",
        WS_VISIBLE | WS_OVERLAPPEDWINDOW,
        CW_USEDEFAULT, CW_USEDEFAULT, 450, 260,
        NULL, NULL, hInstance, NULL);

    if(hwnd == NULL) {
        MessageBox(NULL, "Window Creation Failed!","Error!",MB_ICONEXCLAMATION|MB_OK);
        return 0;
    }	

	// Ŷб
	SystemLang = CreateWindowEx(
	    0,                             // չʽ
	    "COMBOBOX",                   // ComboBox ע "COMBOBOX"
	    NULL,                          // Ĭϱ
	    CBS_DROPDOWNLIST | WS_CHILD | WS_VISIBLE | WS_VSCROLL,  // ComboBox ʽ
	    INFO_LEFT_MARGIN, 10,                        // x, y λ
	    150, 200,                      // Ⱥ͸߶
	    hwnd,                          // ھ
	    0,                          // ؼIDʶؼ
	    hInstance,                     // ʵ
	    NULL                           // ޸Ӳ
	);
	
	// бӵб
	for(int i = 0;i < GetSystemLangLen();i++){
	    //  ComboBox ѡ
	    SendMessage(SystemLang, CB_ADDSTRING, 0, (LPARAM)SystemLangList[i]);
	}
	
	// Ĭѡеһѡ
	SendMessage(SystemLang, CB_SETCURSEL, (WPARAM)0, 0);

	// ϵͳб
	SystemVersion = CreateWindowEx(
	    0,                             // չʽ
	    "COMBOBOX",                   // ComboBox ע "COMBOBOX"
	    NULL,                          // Ĭϱ
	    CBS_DROPDOWNLIST | WS_CHILD | WS_VISIBLE | WS_VSCROLL,  // ComboBox ʽ
	    INFO_LEFT_MARGIN, 50,                        // x, y λ
	    350, 500,                      // Ⱥ͸߶
	    hwnd,                          // ھ
	    1,                          // ؼIDʶؼ
	    hInstance,                     // ʵ
	    NULL                           // ޸Ӳ
	);

	// ϵͳ汾ӵб
	for(int i = 0;i < GetSystemListLen();i++){
	    //  ComboBox ѡ
	    SendMessage(SystemVersion, CB_ADDSTRING, 0, (LPARAM)SystemVersionList[i].English);
	}

	// Ĭѡеһѡ
	SendMessage(SystemVersion, CB_SETCURSEL, (WPARAM)0, 0);
	
	
	// ǩ
	ActionServerText = CreateWindowEx(
	    0,                      // չʽ
	    "STATIC",              // ǩ
	    ActionServerStr[CurSystemLang],        // ǩı
	    WS_VISIBLE | WS_CHILD, // ǩʽ
	    INFO_LEFT_MARGIN, 90,               // x, y λ
	    150, 20,               // Ⱥ͸߶
	    hwnd,                  // ھ
	    NULL,                  // ؼID
	    hInstance,            // ʵ
	    NULL                   // Ӳ
	);
	
	// һ򣨱༭ؼ
	ActionServerAddr = CreateWindowEx(
	    0,                       // չʽ
	    "EDIT",                  // ؼ
	    "kms.03k.org",           // Ĭı
	    WS_CHILD | WS_VISIBLE | WS_BORDER | ES_LEFT, // ʽ
	    INFO_LEFT_MARGIN, 120,                 // x, y λ
	    150, 24,                // Ⱥ͸߶
	    hwnd,                   // ھ
	    NULL,                   // ؼID
	    hInstance,             // ʵ
	    NULL                    // Ӳ
	);
	
	// ť
	ActionBtn = CreateWindowEx(
	    0,                      // չʽ
	    "BUTTON",               // ť
	    ActionBtnStr[CurSystemLang],              // ťı
	    WS_TABSTOP | WS_VISIBLE | WS_CHILD | BS_DEFPUSHBUTTON, // ťʽ
	    INFO_LEFT_MARGIN, 160,                // x, y λ
	    100, 30,               // Ⱥ͸߶
	    hwnd,                  // ھ
	    START_ACTION_BTN_ID,                  // ؼID
	    hInstance,            // ʵ
	    NULL                   // Ӳ
	);
	

    // Ϣѭ
    while(GetMessage(&msg, NULL, 0, 0) > 0) {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }

    return msg.wParam;
}

// ȡѡб
int GetSystemLangLen(void)
{
	int SystemLangNum = 0x00;
	
	while(1){
		if(SystemLangList[SystemLangNum] == NULL)
		{
			break;
		}
		else
		{
			SystemLangNum++;
		}
	}
	
	return (SystemLangNum);
}

// ȡϵͳ汾бĳ
int GetSystemListLen(void)
{
	int SystemListNum = 0x00;
	
	while(1){
		if(SystemVersionList[SystemListNum].Key == NULL)
		{
			break;
		}
		else
		{
			SystemListNum++;
		}
	}
	
	return (SystemListNum);
}

// ִslmgr
void RunSlmgrCommand(const char* command) 
{
    // ַ
    char fullCommand[256];
    snprintf(fullCommand, sizeof(fullCommand), "cmd.exe /c %s", command);

    // ִ
    ShellExecute(NULL, "runas", "cmd.exe", fullCommand, NULL, SW_SHOWNORMAL);
}

// װԿ
void InstallKey(void)
{
	char BaseCmd[256] = {"slmgr /ipk "};

	snprintf(BaseCmd + strlen(BaseCmd), sizeof(BaseCmd) - strlen(BaseCmd), "%s", ActionInfo.Key);
	
	RunSlmgrCommand(BaseCmd);
	
	//MessageBox(hwnd, BaseCmd, "ʾ", MB_OK | MB_ICONINFORMATION);
}

// ü
void SetActionServer(void)
{
	char BaseCmd[256] = {"slmgr /skms "};

	snprintf(BaseCmd + strlen(BaseCmd), sizeof(BaseCmd) - strlen(BaseCmd), "%s", ActionInfo.ActionServer);
	
	RunSlmgrCommand(BaseCmd);
	
	//MessageBox(hwnd, BaseCmd, "ʾ", MB_OK | MB_ICONINFORMATION);
}

// ʼ
void StartAction(void)
{
	char BaseCmd[256] = {"slmgr /ato "};
	
	RunSlmgrCommand(BaseCmd);
	
	//MessageBox(hwnd, BaseCmd, "ʾ", MB_OK | MB_ICONINFORMATION);
}

// ʼִм
void ExecActionCommand(void)
{
	InstallKey();
	SetActionServer();
	StartAction();
}


//Ӣ
void TranslateEnglish(void)
{
	//ϵͳ汾б
	SendMessage(SystemVersion, CB_RESETCONTENT, 0, 0);
	
	//
	// ϵͳ汾ӵб
	for(int i = 0;i < GetSystemListLen();i++){
	    //  ComboBox ѡ
	    SendMessage(SystemVersion, CB_ADDSTRING, 0, (LPARAM)SystemVersionList[i].English);
	}
	
	// ޸ļıǩ
	SendMessage(ActionServerText, WM_SETTEXT, 0, (LPARAM)ActionServerStr[CurSystemLang]);
	
	// ޸ļťı
	SendMessage(ActionBtn, WM_SETTEXT, 0, (LPARAM)ActionBtnStr[CurSystemLang]);
}
//
void TranslateChinese(void)
{
	SendMessage(SystemVersion, CB_RESETCONTENT, 0, 0);
	
	//
	// ϵͳ汾ӵб
	for(int i = 0;i < GetSystemListLen();i++){
	    //  ComboBox ѡ
	    SendMessage(SystemVersion, CB_ADDSTRING, 0, (LPARAM)SystemVersionList[i].Chinese);
	}
	
	// ޸ļıǩ
	SendMessage(ActionServerText, WM_SETTEXT, 0, (LPARAM)ActionServerStr[CurSystemLang]);
	
	// ޸ļťı
	SendMessage(ActionBtn, WM_SETTEXT, 0, (LPARAM)ActionBtnStr[CurSystemLang]);
}

//
void TranslateApp(void)
{
	switch (CurSystemLang) {
		case ENGLISH:
			TranslateEnglish();
			break;
		case CHINESE:
			TranslateChinese();
			break;
		default:
			TranslateEnglish();
			break;
	}
	
	// Ĭϵͳ汾ѡеһѡ
	SendMessage(SystemVersion, CB_SETCURSEL, (WPARAM)0, 0);
}
